//
//		TEXIO USB488 Access Lib  Ver 1.00
//

#include "stdafx.h"
#include  "IF70_API.h"


IF70_API::IF70_API()
{
	m_IF70_APIDll       = NULL;
	m_IF70_DeviceOpen 	= NULL;
	m_IF70_DeviceClose 	= NULL;
	m_IF70_Send			= NULL;
	m_IF70_SendBinary	= NULL;
	m_IF70_Receive		= NULL;
	m_IF70_SetTimeout	= NULL;
	m_IF70_SetRemote	= NULL;
	m_IF70_GetRemote	= NULL;
	m_IF70_DevClear		= NULL;
	m_IF70_GetSTBQuery	= NULL;
	m_IF70_DevClear		= NULL;
	m_IF70_ClearSTB		= NULL;
}

IF70_API::~IF70_API()
{
	if(m_IF70_APIDll != NULL)
		FreeLibrary(m_IF70_APIDll);
}

//////////////////////////////////////////////////
// ֐ :	IFInitialize						//
// @\   : USB IF ̏A					//
//			Cuyъ֐̃nh̎擾	//
// 	  : Ȃ								//
// ߂l : TRUE	I					//
//		    FAULSE	ُI					//
//////////////////////////////////////////////////

BOOL IF70_API::IFInitialize()
{
	m_IF70_APIDll=LoadLibrary((LPCSTR)"IF_60.dll");
	if( m_IF70_APIDll == NULL )
		return FALSE;

	m_IF70_DeviceOpen = (long ( __stdcall* )( int )) GetProcAddress(m_IF70_APIDll , "USB488_DeviceOpen");
	if( m_IF70_DeviceOpen == NULL )
		return FALSE;

	m_IF70_DeviceClose = (int ( __stdcall* )( int )) GetProcAddress(m_IF70_APIDll , "USB488_DeviceClose");
	if( m_IF70_DeviceClose == NULL )
		return FALSE;

	m_IF70_Send = (int ( __stdcall* )( int , char* )) GetProcAddress(m_IF70_APIDll , "USB488_Send");
	if( m_IF70_Send == NULL )
		return FALSE;

	m_IF70_SendBinary = (int ( __stdcall* )( int ,char *,int , int )) GetProcAddress(m_IF70_APIDll , "USB488_SendBinary");
	if( m_IF70_Send == NULL )
		return FALSE;

	m_IF70_Receive = (int ( __stdcall* )( int  , int , char* )) GetProcAddress(m_IF70_APIDll , "USB488_Receive");
	if( m_IF70_Receive == NULL )
		return FALSE;

	m_IF70_SetTimeout = (int ( __stdcall* )( int  , int )) GetProcAddress(m_IF70_APIDll , "USB488_SetTimeout");
	if( m_IF70_SetTimeout == NULL )
		return FALSE;

	m_IF70_SetRemote = (int ( __stdcall* )( int  , int )) GetProcAddress(m_IF70_APIDll , "USB488_SetRemote");
	if( m_IF70_SetRemote == NULL )
		return FALSE;

	m_IF70_GetRemote  = (int ( __stdcall* )( int )) GetProcAddress(m_IF70_APIDll , "USB488_GetRemote");
	if( m_IF70_GetRemote == NULL )
		return FALSE;

	m_IF70_DevClear  = (int ( __stdcall* )( int )) GetProcAddress(m_IF70_APIDll , "USB488_DevClear");
	if( m_IF70_DevClear == NULL )
		return FALSE;

	m_IF70_GetSTBQuery  = (int ( __stdcall* )( int )) GetProcAddress(m_IF70_APIDll , "USB488_GetSTBQuery");
	if( m_IF70_GetSTBQuery == NULL )
		return FALSE;

	m_IF70_ClearSTB  = (int ( __stdcall* )( int )) GetProcAddress(m_IF70_APIDll , "USB488_ClearSTB");
	if( m_IF70_ClearSTB == NULL )
		return FALSE;

	return TRUE;
} 

//////////////////////////////////////////////////
// ֐:DeviceOpen							//
// @\  :nhI[v				//
//   :long addrs=PCAhX					//
// ߂l:l=Al=s					//
//////////////////////////////////////////////////
long IF70_API::DeviceOpen( int addrs )
{

	if(m_IF70_DeviceOpen == NULL)
		return DLL_ERROR;

	return m_IF70_DeviceOpen( addrs );

}

//////////////////////////////////////////////////
// ֐:DeviceClose							//
// @\  :nhN[Y				//
//   :int hID=ID No.						//
// ߂l:0=,Else=s						//
//////////////////////////////////////////////////

int IF70_API::DeviceClose( int hID )
{
	if(m_IF70_DeviceClose == NULL)
		return DLL_ERROR;

	return m_IF70_DeviceClose( hID );

}



//////////////////////////////////////////////////
// ֐:Send									//
// @\  :R}hM							//
//		  int hID :IDԍ						//
//		  char *str:MR}h				//
//////////////////////////////////////////////////

int IF70_API::Send( int hID , char *str )
{
	if(m_IF70_Send == NULL)
		return DLL_ERROR;

	return	m_IF70_Send( hID ,str );
}

//////////////////////////////////////////////////
// ֐:SendBinary							//
// @\  :f[^M							//
//		  int hID :IDԍ						//
//		  char *str:Mf[^					//
//        int iCount:]oCg               //
//        int iMode:I[hAkpPbgt//
//////////////////////////////////////////////////

int IF70_API::SendBinary( int hID , char *str ,int iCount , int iMode )
{
	if(m_IF70_SendBinary == NULL)
		return DLL_ERROR;

	return	m_IF70_SendBinary( hID ,str , iCount , iMode);
}


//////////////////////////////////////////////////
// ֐:Receive								//
// @\  :bZ[WM						//
//		  int hID :IDԍ						//
//		  char &Query:MbZ[W			//
//////////////////////////////////////////////////

int IF70_API::Receive( int hID , int iCount ,char *Query )
{
	if(m_IF70_Receive == NULL)
		return DLL_ERROR;

	return	m_IF70_Receive( hID , iCount ,Query );
}


//////////////////////////////////////////////////
// ֐:SetTimeout							//
// @\  :^CAEgݒ						//
//		  int hID :IDԍ						//
//		  int tTime:^CAEgimsj			//
//////////////////////////////////////////////////

int IF70_API::SetTimeout( int hID , int tTime )
{
	if(m_IF70_SetTimeout == NULL)
		return DLL_ERROR;

	return	m_IF70_SetTimeout( hID ,tTime );
}
//////////////////////////////////////////////////
// ֐:SetRemote								//
// @\  :[g[hݒ					//
//		  int hID :IDԍ						//
//		  int iMode:[h	0:[J			//
//							1:[g			//
//							2:[gFbN	//
//////////////////////////////////////////////////

int IF70_API::SetRemote( int hID , int iMode )
{
	if(m_IF70_SetRemote == NULL)
		return DLL_ERROR;

	return	m_IF70_SetRemote( hID ,iMode );
}

//////////////////////////////////////////////////
// ֐:GetRemote								//
// @\  :[gԂl				//
//   :int hID=ID No.						//
// ߂l:int@mode [h						//
//////////////////////////////////////////////////

int IF70_API::GetRemote( int hID )
{
	if(m_IF70_GetRemote == NULL)
		return DLL_ERROR;

	return m_IF70_GetRemote( hID );

}
//////////////////////////////////////////////////
// ֐:DevClear								//
// @\  :foCXNAo					//
//   :int hID=ID No.						//
// ߂l:0=,Else=s						//
//////////////////////////////////////////////////

int IF70_API::DevClear( int hID )
{
	if(m_IF70_DevClear == NULL)
		return DLL_ERROR;

	return m_IF70_DevClear( hID );

}
//////////////////////////////////////////////////
// ֐:GetSTBQuery							//
// @\  :STB荞							//
//   :int hID=ID No.						//
// ߂l:int STB								//
//////////////////////////////////////////////////

int IF70_API::GetSTBQuery( int hID )
{
	if(m_IF70_GetSTBQuery == NULL)
		return DLL_ERROR;

	return m_IF70_GetSTBQuery( hID );

}
//////////////////////////////////////////////////
// ֐:ClearSTB								//
// @\  :STBNA						//
//   :int hID=ID No.						//
// ߂l:0=,Else=s						//
//////////////////////////////////////////////////

int IF70_API::ClearSTB( int hID )
{
	if(m_IF70_ClearSTB == NULL)
		return DLL_ERROR;

	return m_IF70_ClearSTB( hID );

}
